Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Tests/Interpreter/ExpressionTest.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/ExpressionTest.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Tests/Interpreter/ExpressionTest.cs	(revision 15771)
@@ -1,17 +1,6 @@
-﻿namespace HeuristicLab.Tests.Interpreter {
-  using HeuristicLab.Problems.ProgramSynthesis.Base.Erc.Boolean;
-  using HeuristicLab.Problems.ProgramSynthesis.Base.Erc.Float;
-  using HeuristicLab.Problems.ProgramSynthesis.Base.Erc.FloatVector;
-  using HeuristicLab.Problems.ProgramSynthesis.Base.Erc.IntegerVector;
-  using HeuristicLab.Problems.ProgramSynthesis.Base.Erc.StringVector;
+﻿using HeuristicLab.Problems.ProgramSynthesis;
+using Microsoft.VisualStudio.TestTools.UnitTesting;
 
-  using Microsoft.VisualStudio.TestTools.UnitTesting;
-  using Problems.ProgramSynthesis.Base.Erc;
-  using Problems.ProgramSynthesis.Base.Erc.Char;
-  using Problems.ProgramSynthesis.Base.Erc.Integer;
-  using Problems.ProgramSynthesis.Base.Erc.String;
-  using Problems.ProgramSynthesis.Push.Configuration;
-  using Problems.ProgramSynthesis.Push.Interpreter;
-
+namespace HeuristicLab.Tests.Interpreter {
   public class ExpressionTest {
     protected PushInterpreter interpreter;
Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Tests/Interpreter/Expressions/BooleanExpressionTests.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/BooleanExpressionTests.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Tests/Interpreter/Expressions/BooleanExpressionTests.cs	(revision 15771)
@@ -1,22 +1,16 @@
-﻿namespace HeuristicLab.Tests.Interpreter.Expressions {
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
+﻿using HeuristicLab.Problems.ProgramSynthesis;
+using Microsoft.VisualStudio.TestTools.UnitTesting;
 
-  using Microsoft.VisualStudio.TestTools.UnitTesting;
-
+namespace HeuristicLab.Tests.Interpreter.Expressions {
   [TestClass]
   public class BooleanExpressionTests : CommonTests<bool> {
-    protected override string TypeName
-    {
-      get
-      {
+    protected override string TypeName {
+      get {
         return "BOOLEAN";
       }
     }
 
-    protected override IPushStack<bool> Stack
-    {
-      get
-      {
+    protected override IPushStack<bool> Stack {
+      get {
         return interpreter.BooleanStack;
       }
Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Tests/Interpreter/Expressions/BooleanVectorExpressionsTests.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/BooleanVectorExpressionsTests.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Tests/Interpreter/Expressions/BooleanVectorExpressionsTests.cs	(revision 15771)
@@ -1,7 +1,7 @@
 ﻿using System.Collections.Generic;
 using System.Linq;
+using HeuristicLab.Problems.ProgramSynthesis;
 
 namespace HeuristicLab.Tests.Interpreter.Expressions {
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
 
   using Microsoft.VisualStudio.TestTools.UnitTesting;
Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Tests/Interpreter/Expressions/CharExpressionTests.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/CharExpressionTests.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Tests/Interpreter/Expressions/CharExpressionTests.cs	(revision 15771)
@@ -1,10 +1,7 @@
-﻿namespace HeuristicLab.Tests.Interpreter.Expressions {
-  using System.Linq;
+﻿using System.Linq;
+using HeuristicLab.Problems.ProgramSynthesis;
+using Microsoft.VisualStudio.TestTools.UnitTesting;
 
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
-
-  using Microsoft.VisualStudio.TestTools.UnitTesting;
-
+namespace HeuristicLab.Tests.Interpreter.Expressions {
   [TestClass]
   public class CharExpressionTests : CommonTests<char> {
Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Tests/Interpreter/Expressions/CodeExpressionTests.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/CodeExpressionTests.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Tests/Interpreter/Expressions/CodeExpressionTests.cs	(revision 15771)
@@ -1,23 +1,17 @@
-﻿namespace HeuristicLab.Tests.Interpreter.Expressions {
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Parser;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
-  using Microsoft.VisualStudio.TestTools.UnitTesting;
-
+﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
+using HeuristicLab.Problems.ProgramSynthesis;
+
+namespace HeuristicLab.Tests.Interpreter.Expressions {
 
   [TestClass]
   public class CodeExpressionTests : CommonTests<Expression> {
-    protected override string TypeName
-    {
-      get
-      {
+    protected override string TypeName {
+      get {
         return "CODE";
       }
     }
 
-    protected override IPushStack<Expression> Stack
-    {
-      get
-      {
+    protected override IPushStack<Expression> Stack {
+      get {
         return interpreter.CodeStack;
       }
Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Tests/Interpreter/Expressions/CommonTests.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/CommonTests.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Tests/Interpreter/Expressions/CommonTests.cs	(revision 15771)
@@ -1,8 +1,6 @@
-﻿namespace HeuristicLab.Tests.Interpreter.Expressions {
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
-
-  using Microsoft.VisualStudio.TestTools.UnitTesting;
-
+﻿using HeuristicLab.Problems.ProgramSynthesis;
+using Microsoft.VisualStudio.TestTools.UnitTesting;
+
+namespace HeuristicLab.Tests.Interpreter.Expressions {
   public abstract class CommonTests<T> : ExpressionTest {
     protected const string FullInstructionNameFormat = "{0}.{1}";
Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Tests/Interpreter/Expressions/ExampleTests.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/ExampleTests.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Tests/Interpreter/Expressions/ExampleTests.cs	(revision 15771)
@@ -1,4 +1,4 @@
 ﻿namespace HeuristicLab.Tests.Interpreter.Expressions {
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Parser;
+  using HeuristicLab.Problems.ProgramSynthesis;
 
   using Microsoft.VisualStudio.TestTools.UnitTesting;
Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Tests/Interpreter/Expressions/ExecExpressionTests.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/ExecExpressionTests.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Tests/Interpreter/Expressions/ExecExpressionTests.cs	(revision 15771)
@@ -1,23 +1,16 @@
-﻿namespace HeuristicLab.Tests.Interpreter.Expressions {
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Parser;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
+﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
+using HeuristicLab.Problems.ProgramSynthesis;
 
-  using Microsoft.VisualStudio.TestTools.UnitTesting;
-
+namespace HeuristicLab.Tests.Interpreter.Expressions {
   [TestClass]
   public class ExecExpressionTests : CommonTests<Expression> {
-    protected override string TypeName
-    {
-      get
-      {
+    protected override string TypeName {
+      get {
         return "EXEC";
       }
     }
 
-    protected override IPushStack<Expression> Stack
-    {
-      get
-      {
+    protected override IPushStack<Expression> Stack {
+      get {
         return interpreter.ExecStack;
       }
Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Tests/Interpreter/Expressions/FloatExpressionTests.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/FloatExpressionTests.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Tests/Interpreter/Expressions/FloatExpressionTests.cs	(revision 15771)
@@ -1,26 +1,19 @@
-﻿namespace HeuristicLab.Tests.Interpreter.Expressions {
-  using System;
-
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
-
-  using Microsoft.VisualStudio.TestTools.UnitTesting;
-
+﻿using System;
+using HeuristicLab.Problems.ProgramSynthesis;
+using Microsoft.VisualStudio.TestTools.UnitTesting;
+
+namespace HeuristicLab.Tests.Interpreter.Expressions {
   [TestClass]
   public class FloatExpressionTests : CommonTests<double> {
     private const double delta = 0.00001;
 
-    protected override string TypeName
-    {
-      get
-      {
+    protected override string TypeName {
+      get {
         return "FLOAT";
       }
     }
 
-    protected override IPushStack<double> Stack
-    {
-      get
-      {
+    protected override IPushStack<double> Stack {
+      get {
         return interpreter.FloatStack;
       }
Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Tests/Interpreter/Expressions/FloatVectorExpressionTests.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/FloatVectorExpressionTests.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Tests/Interpreter/Expressions/FloatVectorExpressionTests.cs	(revision 15771)
@@ -1,10 +1,8 @@
 ﻿using System.Collections.Generic;
 using System.Linq;
+using HeuristicLab.Problems.ProgramSynthesis;
+using Microsoft.VisualStudio.TestTools.UnitTesting;
 
 namespace HeuristicLab.Tests.Interpreter.Expressions {
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
-
-  using Microsoft.VisualStudio.TestTools.UnitTesting;
-
   [TestClass]
   public class FloatVectorExpressionTests : VectorExpressionTests<double> {
Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Tests/Interpreter/Expressions/IntegerExpressionTests.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/IntegerExpressionTests.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Tests/Interpreter/Expressions/IntegerExpressionTests.cs	(revision 15771)
@@ -1,22 +1,16 @@
-﻿namespace HeuristicLab.Tests.Interpreter.Expressions {
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
-
-  using Microsoft.VisualStudio.TestTools.UnitTesting;
-
+﻿using HeuristicLab.Problems.ProgramSynthesis;
+using Microsoft.VisualStudio.TestTools.UnitTesting;
+
+namespace HeuristicLab.Tests.Interpreter.Expressions {
   [TestClass]
   public class IntegerExpressionTests : CommonTests<long> {
-    protected override string TypeName
-    {
-      get
-      {
+    protected override string TypeName {
+      get {
         return "INTEGER";
       }
     }
 
-    protected override IPushStack<long> Stack
-    {
-      get
-      {
+    protected override IPushStack<long> Stack {
+      get {
         return interpreter.IntegerStack;
       }
Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Tests/Interpreter/Expressions/IntegerVectorExpressionTests.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/IntegerVectorExpressionTests.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Tests/Interpreter/Expressions/IntegerVectorExpressionTests.cs	(revision 15771)
@@ -1,7 +1,7 @@
 ﻿using System.Collections.Generic;
 using System.Linq;
+using HeuristicLab.Problems.ProgramSynthesis;
 
 namespace HeuristicLab.Tests.Interpreter.Expressions {
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
 
   using Microsoft.VisualStudio.TestTools.UnitTesting;
Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Tests/Interpreter/Expressions/NameExpressionTests.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/NameExpressionTests.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Tests/Interpreter/Expressions/NameExpressionTests.cs	(revision 15771)
@@ -1,23 +1,17 @@
-﻿namespace HeuristicLab.Tests.Interpreter.Expressions {
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Generators;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
+﻿using HeuristicLab.Problems.ProgramSynthesis;
+using Microsoft.VisualStudio.TestTools.UnitTesting;
 
-  using Microsoft.VisualStudio.TestTools.UnitTesting;
+namespace HeuristicLab.Tests.Interpreter.Expressions {
 
   [TestClass]
   public class NameExpressionTests : CommonTests<string> {
-    protected override string TypeName
-    {
-      get
-      {
+    protected override string TypeName {
+      get {
         return "NAME";
       }
     }
 
-    protected override IPushStack<string> Stack
-    {
-      get
-      {
+    protected override IPushStack<string> Stack {
+      get {
         return interpreter.NameStack;
       }
Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Tests/Interpreter/Expressions/PrintExpressionTests.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/PrintExpressionTests.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Tests/Interpreter/Expressions/PrintExpressionTests.cs	(revision 15771)
@@ -2,5 +2,5 @@
   using System.Globalization;
 
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
+  using HeuristicLab.Problems.ProgramSynthesis;
 
   using Microsoft.VisualStudio.TestTools.UnitTesting;
Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Tests/Interpreter/Expressions/PushProgramTests.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/PushProgramTests.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Tests/Interpreter/Expressions/PushProgramTests.cs	(revision 15771)
@@ -1,7 +1,6 @@
-﻿namespace HeuristicLab.Tests.Interpreter.Expressions {
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Parser;
+﻿using HeuristicLab.Problems.ProgramSynthesis;
+using Microsoft.VisualStudio.TestTools.UnitTesting;
 
-  using Microsoft.VisualStudio.TestTools.UnitTesting;
-
+namespace HeuristicLab.Tests.Interpreter.Expressions {
   [TestClass]
   public class PushProgramTests : ExpressionTest {
Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Tests/Interpreter/Expressions/StandardTests.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/StandardTests.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Tests/Interpreter/Expressions/StandardTests.cs	(revision 15771)
@@ -1,13 +1,10 @@
-﻿namespace HeuristicLab.Tests.Interpreter.Expressions {
-  using System;
-  using System.Collections.Generic;
-  using System.Diagnostics;
-  using System.Linq;
+﻿using System;
+using System.Collections.Generic;
+using System.Diagnostics;
+using System.Linq;
+using HeuristicLab.Problems.ProgramSynthesis;
+using Microsoft.VisualStudio.TestTools.UnitTesting;
 
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Parser;
-
-  using Microsoft.VisualStudio.TestTools.UnitTesting;
-
+namespace HeuristicLab.Tests.Interpreter.Expressions {
   [TestClass]
   public class StandardTests {
Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Tests/Interpreter/Expressions/StringExpressionTests.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/StringExpressionTests.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Tests/Interpreter/Expressions/StringExpressionTests.cs	(revision 15771)
@@ -1,7 +1,6 @@
 ﻿using System.Linq;
+using HeuristicLab.Problems.ProgramSynthesis;
 
 namespace HeuristicLab.Tests.Interpreter.Expressions {
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
 
   using Microsoft.VisualStudio.TestTools.UnitTesting;
Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Tests/Interpreter/Expressions/StringVectorExpressionTests.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/StringVectorExpressionTests.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Tests/Interpreter/Expressions/StringVectorExpressionTests.cs	(revision 15771)
@@ -1,10 +1,8 @@
-﻿namespace HeuristicLab.Tests.Interpreter.Expressions {
-  using System.Collections.Generic;
-  using System.Linq;
+﻿using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Problems.ProgramSynthesis;
+using Microsoft.VisualStudio.TestTools.UnitTesting;
 
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
-
-  using Microsoft.VisualStudio.TestTools.UnitTesting;
-
+namespace HeuristicLab.Tests.Interpreter.Expressions {
   [TestClass]
   public class StringVectorExpressionTests : VectorExpressionTests<string> {
Index: branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Tests/Interpreter/Expressions/VectorExpressionTests.cs
===================================================================
--- addons/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/Expressions/VectorExpressionTests.cs	(revision 15692)
+++ branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Tests/Interpreter/Expressions/VectorExpressionTests.cs	(revision 15771)
@@ -2,8 +2,5 @@
   using System.Collections.Generic;
   using System.Linq;
-
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
-
+  using HeuristicLab.Problems.ProgramSynthesis;
   using Microsoft.VisualStudio.TestTools.UnitTesting;
 