Index: /branches/2886_SymRegGrammarEnumeration/HeuristicLab.Algorithms.DataAnalysis.SymRegGrammarEnumeration/GrammarEnumeration/GrammarEnumerationAlgorithm.cs
===================================================================
--- /branches/2886_SymRegGrammarEnumeration/HeuristicLab.Algorithms.DataAnalysis.SymRegGrammarEnumeration/GrammarEnumeration/GrammarEnumerationAlgorithm.cs	(revision 15775)
+++ /branches/2886_SymRegGrammarEnumeration/HeuristicLab.Algorithms.DataAnalysis.SymRegGrammarEnumeration/GrammarEnumeration/GrammarEnumerationAlgorithm.cs	(revision 15776)
@@ -84,6 +84,6 @@
 
     public GrammarEnumerationAlgorithm() {
-      var provider = new HeuristicLab.Problems.Instances.DataAnalysis.VariousInstanceProvider(seed: 1234);
-      var regProblem = provider.LoadData(provider.GetDataDescriptors().Single(x => x.Name.Contains("Poly-10")));
+      var provider = new HeuristicLab.Problems.Instances.DataAnalysis.NguyenInstanceProvider(seed: 1234);
+      var regProblem = provider.LoadData(provider.GetDataDescriptors().Single(x => x.Name.Contains("F9 ")));
 
       Problem = new RegressionProblem() {
Index: /branches/2886_SymRegGrammarEnumeration/Test/GrammarEnumerationTest.cs
===================================================================
--- /branches/2886_SymRegGrammarEnumeration/Test/GrammarEnumerationTest.cs	(revision 15775)
+++ /branches/2886_SymRegGrammarEnumeration/Test/GrammarEnumerationTest.cs	(revision 15776)
@@ -1,12 +1,9 @@
 ﻿using System;
-using System.Diagnostics;
 using System.Linq;
 using HeuristicLab.Algorithms.DataAnalysis.SymRegGrammarEnumeration;
 using HeuristicLab.Algorithms.DataAnalysis.SymRegGrammarEnumeration.GrammarEnumeration;
-using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HeuristicLab.Data;
-using HeuristicLab.Optimization;
 using HeuristicLab.Problems.DataAnalysis;
+using HeuristicLab.Problems.Instances.DataAnalysis;
 using HeuristicLab.Random;
 using Microsoft.VisualStudio.TestTools.UnitTesting;
@@ -58,8 +55,5 @@
       // x³ + x² + x
       alg.MaxTreeSize = 15;
-      Console.WriteLine(alg.MaxTreeSize);
-      var provider = new HeuristicLab.Problems.Instances.DataAnalysis.NguyenInstanceProvider(Seed);
-      var regProblem = provider.LoadData(provider.GetDataDescriptors().Single(x => x.Name.Contains("F1 ")));
-      alg.Problem.ProblemData = regProblem;
+      alg.Problem.ProblemData = new NguyenFunctionOne(Seed).GenerateRegressionData(); 
 
       alg.Start();
@@ -92,7 +86,5 @@
       // x^4 + x³ + x² + x
       alg.MaxTreeSize = 20;
-      var provider = new HeuristicLab.Problems.Instances.DataAnalysis.NguyenInstanceProvider(Seed);
-      var regProblem = provider.LoadData(provider.GetDataDescriptors().Single(x => x.Name.Contains("F2 ")));
-      alg.Problem.ProblemData = regProblem;
+      alg.Problem.ProblemData = new NguyenFunctionTwo(Seed).GenerateRegressionData();
 
       alg.Start();
@@ -106,7 +98,5 @@
       // x^5 + x^4 + x^3 + x^2 + x
       alg.MaxTreeSize = 32;
-      var provider = new HeuristicLab.Problems.Instances.DataAnalysis.NguyenInstanceProvider(Seed);
-      var regProblem = provider.LoadData(provider.GetDataDescriptors().Single(x => x.Name.Contains("F3 ")));
-      alg.Problem.ProblemData = regProblem;
+      alg.Problem.ProblemData = new NguyenFunctionThree(Seed).GenerateRegressionData();
 
       alg.Start();
@@ -120,7 +110,5 @@
       // sin(x) + sin(x + x²)
       alg.MaxTreeSize = 15;
-      var provider = new HeuristicLab.Problems.Instances.DataAnalysis.NguyenInstanceProvider(Seed);
-      var regProblem = provider.LoadData(provider.GetDataDescriptors().Single(x => x.Name.Contains("F6 ")));
-      alg.Problem.ProblemData = regProblem;
+      alg.Problem.ProblemData = new NguyenFunctionSix(Seed).GenerateRegressionData();
 
       alg.Start();
@@ -133,7 +121,5 @@
       // sin(x) + sin(y²)
       alg.MaxTreeSize = 10;
-      var provider = new HeuristicLab.Problems.Instances.DataAnalysis.NguyenInstanceProvider(Seed);
-      var regProblem = provider.LoadData(provider.GetDataDescriptors().Single(x => x.Name.Contains("F9 ")));
-      alg.Problem.ProblemData = regProblem;
+      alg.Problem.ProblemData = new NguyenFunctionNine(Seed).GenerateRegressionData();
 
       alg.Start();
@@ -146,7 +132,5 @@
     public void MctsSymbReg_NoConstants_Poly10() {
       alg.MaxTreeSize = 10;
-      var provider = new HeuristicLab.Problems.Instances.DataAnalysis.VariousInstanceProvider(Seed);
-      var regProblem = provider.LoadData(provider.GetDataDescriptors().Single(x => x.Name.Contains("Poly")));
-      alg.Problem.ProblemData = regProblem;
+      alg.Problem.ProblemData = new PolyTen(Seed).GenerateRegressionData();
 
       alg.Start();