Index: /branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis.GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis.GenealogyAnalysis.csproj
===================================================================
--- /branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis.GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis.GenealogyAnalysis.csproj	(revision 15779)
+++ /branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis.GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis.GenealogyAnalysis.csproj	(revision 15780)
@@ -8,8 +8,9 @@
     <OutputType>Library</OutputType>
     <AppDesignerFolder>Properties</AppDesignerFolder>
-    <RootNamespace>HeuristicLab.Problems.ProgramSynthesis.GenealogyAnalysis</RootNamespace>
-    <AssemblyName>HeuristicLab.Problems.ProgramSynthesis.GenealogyAnalysis</AssemblyName>
-    <TargetFrameworkVersion>v4.6.1</TargetFrameworkVersion>
+    <RootNamespace>HeuristicLab.Problems.ProgramSynthesis</RootNamespace>
+    <AssemblyName>HeuristicLab.Problems.ProgramSynthesis.GenealogyAnalysis-3.3</AssemblyName>
+    <TargetFrameworkVersion>v4.5</TargetFrameworkVersion>
     <FileAlignment>512</FileAlignment>
+    <TargetFrameworkProfile />
   </PropertyGroup>
   <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|AnyCPU' ">
@@ -107,6 +108,19 @@
     <Compile Include="Operators\Interfaces\IManipulatorOperator.cs" />
     <Compile Include="Operators\RemovePopulationGraphFromResults.cs" />
+    <Compile Include="Plugin.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
   </ItemGroup>
+  <ItemGroup>
+    <None Include="Plugin.cs.frame" />
+  </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
+  <PropertyGroup>
+    <PreBuildEvent>set Path=%25Path%25;$(ProjectDir);$(SolutionDir)
+set ProjectDir=$(ProjectDir)
+set SolutionDir=$(SolutionDir)
+set Outdir=$(Outdir)
+
+call PreBuildEvent.cmd
+</PreBuildEvent>
+  </PropertyGroup>
 </Project>
Index: /branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis.GenealogyAnalysis/Plugin.cs.frame
===================================================================
--- /branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis.GenealogyAnalysis/Plugin.cs.frame	(revision 15779)
+++ /branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis.GenealogyAnalysis/Plugin.cs.frame	(revision 15780)
@@ -1,5 +1,5 @@
 #region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2017 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -23,6 +23,6 @@
 
 namespace HeuristicLab.Problems.ProgramSynthesis.GenealogyAnalysis {
-  [Plugin("HeuristicLab.Problems.ProgramSynthesis.GenealogyAnalysis", "Provides operators and related classes for genealogy analysis.", "3.4.5.$WCREV$")]
-  [PluginFile("HeuristicLab.Problems.ProgramSynthesis.GenealogyAnalysisg-3.4.dll", PluginFileType.Assembly)]
+  [Plugin("HeuristicLab.Problems.ProgramSynthesis.GenealogyAnalysis", "Provides operators and related classes for genealogy analysis.", "3.3.1.$WCREV$")]
+  [PluginFile("HeuristicLab.Problems.ProgramSynthesis.GenealogyAnalysis-3.3.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Analysis", "3.3")]
   [PluginDependency("HeuristicLab.Collections", "3.3")]
@@ -38,5 +38,5 @@
   [PluginDependency("HeuristicLab.Persistence", "3.3")]
 
-  public class HeuristicLab.Problems.ProgramSynthesis.GenealogyAnalysisPlugin : PluginBase {
+  public class HeuristicLabProblemsProgramSynthesisGenealogyAnalysisPlugin : PluginBase {
   }
 }
Index: /branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis.Views/HeuristicLab.Problems.ProgramSynthesis.Views.csproj
===================================================================
--- /branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis.Views/HeuristicLab.Problems.ProgramSynthesis.Views.csproj	(revision 15779)
+++ /branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis.Views/HeuristicLab.Problems.ProgramSynthesis.Views.csproj	(revision 15780)
@@ -9,7 +9,8 @@
     <AppDesignerFolder>Properties</AppDesignerFolder>
     <RootNamespace>HeuristicLab.Problems.ProgramSynthesis.Views</RootNamespace>
-    <AssemblyName>HeuristicLab.Problems.ProgramSynthesis.Views</AssemblyName>
-    <TargetFrameworkVersion>v4.6.1</TargetFrameworkVersion>
+    <AssemblyName>HeuristicLab.Problems.ProgramSynthesis.Views-3.3</AssemblyName>
+    <TargetFrameworkVersion>v4.5</TargetFrameworkVersion>
     <FileAlignment>512</FileAlignment>
+    <TargetFrameworkProfile />
   </PropertyGroup>
   <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|AnyCPU' ">
@@ -52,4 +53,9 @@
     </Reference>
     <Reference Include="HeuristicLab.MainForm.WindowsForms-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec">
+      <Private>False</Private>
+    </Reference>
+    <Reference Include="HeuristicLab.PluginInfrastructure-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <HintPath>..\..\..\trunk\bin\HeuristicLab.PluginInfrastructure-3.3.dll</HintPath>
       <Private>False</Private>
     </Reference>
@@ -97,4 +103,6 @@
       <DependentUpon>ExpressionSelectionView.cs</DependentUpon>
     </Compile>
+    <None Include="Plugin.cs.frame" />
+    <Compile Include="Plugin.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
     <Compile Include="PushDebuggerView.cs">
@@ -136,3 +144,12 @@
   </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
+  <PropertyGroup>
+    <PreBuildEvent>set Path=%25Path%25;$(ProjectDir);$(SolutionDir)
+set ProjectDir=$(ProjectDir)
+set SolutionDir=$(SolutionDir)
+set Outdir=$(Outdir)
+
+call PreBuildEvent.cmd
+</PreBuildEvent>
+  </PropertyGroup>
 </Project>
Index: /branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis.Views/Plugin.cs.frame
===================================================================
--- /branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis.Views/Plugin.cs.frame	(revision 15780)
+++ /branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis.Views/Plugin.cs.frame	(revision 15780)
@@ -0,0 +1,40 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ *
+ * Author: Patrik Kimmeswegner
+ */
+
+#endregion
+using HeuristicLab.PluginInfrastructure;
+
+namespace HeuristicLab.Problems.ProgramSynthesis {
+  [Plugin("HeuristicLab.Problems.ProgramSynthesis.Views", "Provides views for the program synthesis (PushGP) plugin.", "3.3.1.$WCREV$")]
+  [PluginFile("HeuristicLab.Problems.ProgramSynthesis.Views-3.3.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Collections", "3.3")]
+  [PluginDependency("HeuristicLab.Common", "3.3")]
+  [PluginDependency("HeuristicLab.Core", "3.3")]
+  [PluginDependency("HeuristicLab.Core.Views", "3.3")]
+  [PluginDependency("HeuristicLab.Data", "3.3")]
+  [PluginDependency("HeuristicLab.MainForm", "3.3")]
+  [PluginDependency("HeuristicLab.MainForm.WindowsForms", "3.3")]
+  [PluginDependency("HeuristicLab.Problems.ProgramSynthesis", "3.3")]
+
+  public class HeuristicLabProblemsProgramSynthesisViewsPlugin : PluginBase {
+  }
+}
Index: /branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/HeuristicLab.Problems.ProgramSynthesis.csproj
===================================================================
--- /branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/HeuristicLab.Problems.ProgramSynthesis.csproj	(revision 15779)
+++ /branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/HeuristicLab.Problems.ProgramSynthesis.csproj	(revision 15780)
@@ -9,5 +9,5 @@
     <AppDesignerFolder>Properties</AppDesignerFolder>
     <RootNamespace>HeuristicLab.Problems.ProgramSynthesis</RootNamespace>
-    <AssemblyName>HeuristicLab.Problems.ProgramSynthesis</AssemblyName>
+    <AssemblyName>HeuristicLab.Problems.ProgramSynthesis-3.3</AssemblyName>
     <TargetFrameworkVersion>v4.5</TargetFrameworkVersion>
     <FileAlignment>512</FileAlignment>
@@ -52,8 +52,4 @@
       <HintPath>..\..\..\trunk\bin\HeuristicLab.Core-3.3.dll</HintPath>
     </Reference>
-    <Reference Include="HeuristicLab.Core.Views-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
-      <SpecificVersion>False</SpecificVersion>
-      <HintPath>..\..\..\trunk\bin\HeuristicLab.Core.Views-3.3.dll</HintPath>
-    </Reference>
     <Reference Include="HeuristicLab.Data-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
       <SpecificVersion>False</SpecificVersion>
@@ -63,12 +59,4 @@
       <SpecificVersion>False</SpecificVersion>
       <HintPath>..\..\..\trunk\bin\HeuristicLab.Encodings.IntegerVectorEncoding-3.3.dll</HintPath>
-    </Reference>
-    <Reference Include="HeuristicLab.MainForm-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
-      <SpecificVersion>False</SpecificVersion>
-      <HintPath>..\..\..\trunk\bin\HeuristicLab.MainForm-3.3.dll</HintPath>
-    </Reference>
-    <Reference Include="HeuristicLab.MainForm.WindowsForms-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
-      <SpecificVersion>False</SpecificVersion>
-      <HintPath>..\..\..\trunk\bin\HeuristicLab.MainForm.WindowsForms-3.3.dll</HintPath>
     </Reference>
     <Reference Include="HeuristicLab.Operators-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
@@ -121,4 +109,5 @@
   </ItemGroup>
   <ItemGroup>
+    <None Include="Plugin.cs.frame" />
     <Compile Include="Plugin.cs" />
     <Compile Include="Properties\Resources.Designer.cs">
@@ -177,5 +166,4 @@
     <Compile Include="Push\BenchmarkSuite\ExampleArgumentType.cs" />
     <Compile Include="Push\BenchmarkSuite\IBenchmarkSuiteDataDescriptor.cs" />
-    <Compile Include="Push\BenchmarkSuite\Plugin.cs" />
     <Compile Include="Push\BenchmarkSuite\ProblemData.cs" />
     <Compile Include="Push\BenchmarkSuite\Problems\Checksum.cs" />
@@ -358,4 +346,13 @@
     </PostBuildEvent>
   </PropertyGroup>
+  <PropertyGroup>
+    <PreBuildEvent>set Path=%25Path%25;$(ProjectDir);$(SolutionDir)
+set ProjectDir=$(ProjectDir)
+set SolutionDir=$(SolutionDir)
+set Outdir=$(Outdir)
+
+call PreBuildEvent.cmd
+</PreBuildEvent>
+  </PropertyGroup>
   <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
        Other similar extension points exist, see Microsoft.Common.targets.
Index: anches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Plugin.cs
===================================================================
--- /branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Plugin.cs	(revision 15779)
+++ 	(revision )
@@ -1,49 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- *
- * Author: Patrik Kimmeswegner
- */
-
-#endregion
-using HeuristicLab.PluginInfrastructure;
-
-namespace HeuristicLab.Problems.ProgramSynthesis {
-  [Plugin("HeuristicLab.Problems.ProgramSynthesis", "")]
-  [PluginFile("HeuristicLab.Problems.ProgramSynthesis-1.0.dll", PluginFileType.Assembly)]
-  [PluginDependency("HeuristicLab.Collections", "3.3")]
-  [PluginDependency("HeuristicLab.Common", "3.3")]
-  [PluginDependency("HeuristicLab.Core", "3.3")]
-  [PluginDependency("HeuristicLab.Core.Views", "3.3")]
-  [PluginDependency("HeuristicLab.Data", "3.3")]
-  [PluginDependency("HeuristicLab.Encodings.IntegerVectorEncoding", "3.3")]
-  [PluginDependency("HeuristicLab.MainForm", "3.3")]
-  [PluginDependency("HeuristicLab.MainForm.WindowsForms", "3.3")]
-  [PluginDependency("HeuristicLab.Optimization", "3.3")]
-  [PluginDependency("HeuristicLab.Parameters", "3.3")]
-  [PluginDependency("HeuristicLab.Persistence", "3.3")]
-  [PluginDependency("HeuristicLab.Problems.Instances", "3.3")]
-  [PluginDependency("HeuristicLab.Random", "3.3")]
-  [PluginDependency("HeuristicLab.Selection", "3.3")]
-  [PluginDependency("HeuristicLab.Operators", "3.3")]
-  [PluginDependency("HeuristicLab.Analysis", "3.3")]
-
-  public class Plugin : PluginBase {
-
-  }
-}
Index: /branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Plugin.cs.frame
===================================================================
--- /branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Plugin.cs.frame	(revision 15780)
+++ /branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Plugin.cs.frame	(revision 15780)
@@ -0,0 +1,46 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ *
+ * Author: Patrik Kimmeswegner
+ */
+
+#endregion
+using HeuristicLab.PluginInfrastructure;
+
+namespace HeuristicLab.Problems.ProgramSynthesis {
+  [Plugin("HeuristicLab.Problems.ProgramSynthesis", "Implementation of program synthesis (PushGP) in HeuristicLab", "3.3.1.$WCREV$")]
+  [PluginFile("HeuristicLab.Problems.ProgramSynthesis-3.3.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Analysis", "3.3")]
+  [PluginDependency("HeuristicLab.Collections", "3.3")]
+  [PluginDependency("HeuristicLab.Common", "3.3")]
+  [PluginDependency("HeuristicLab.Core", "3.3")]
+  [PluginDependency("HeuristicLab.Data", "3.3")]
+  [PluginDependency("HeuristicLab.Encodings.IntegerVectorEncoding", "3.3")]
+  [PluginDependency("HeuristicLab.Operators", "3.3")]
+  [PluginDependency("HeuristicLab.Optimization", "3.3")]
+  [PluginDependency("HeuristicLab.Parameters", "3.3")]
+  [PluginDependency("HeuristicLab.Persistence", "3.3")]
+  [PluginDependency("HeuristicLab.Problems.Instances", "3.3")]
+  [PluginDependency("HeuristicLab.Random", "3.3")]
+  [PluginDependency("HeuristicLab.Selection", "3.3")]
+
+  public class HeuristicLabProblemsProgramSynthesisPlugin : PluginBase {
+
+  }
+}
Index: /branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/BenchmarkSuite/BenchmarkSuiteDataDescriptor.cs
===================================================================
--- /branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/BenchmarkSuite/BenchmarkSuiteDataDescriptor.cs	(revision 15779)
+++ /branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/BenchmarkSuite/BenchmarkSuiteDataDescriptor.cs	(revision 15780)
@@ -9,5 +9,5 @@
 
   public abstract class BenchmarkSuiteDataDescriptor : IBenchmarkSuiteDataDescriptor {
-    private const string InstanceArchiveName = "HeuristicLab.BenchmarkSuite.Data.BenchmarkExamples.zip";
+    private const string InstanceArchiveName = "HeuristicLab.Problems.ProgramSynthesis.Push.BenchmarkSuite.Data.BenchmarkExamples.zip";
     private const string ResourcePath = @".*\.Data\.";
     private const char ExampleFieldDelimiter = ',';
Index: anches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/BenchmarkSuite/Plugin.cs
===================================================================
--- /branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Problems.ProgramSynthesis/Push/BenchmarkSuite/Plugin.cs	(revision 15779)
+++ 	(revision )
@@ -1,42 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- *
- * Author: Patrik Kimmeswegner
- */
-
-#endregion
-
-namespace HeuristicLab.BenchmarkSuite {
-  using HeuristicLab.PluginInfrastructure;
-
-  [Plugin("HeuristicLab.Problems.ProgramSynthesis.BenchmarkSuite", "1.0")]
-  [PluginFile("HeuristicLab.Problems.ProgramSynthesis.BenchmarkSuite.dll", PluginFileType.Assembly)]
-  [PluginFile("Microsoft.IO.RecyclableMemoryStream.dll", PluginFileType.Assembly)]
-  [PluginDependency("HeuristicLab.Problems.ProgramSynthesis.Base", "1.0")]
-  [PluginDependency("HeuristicLab.Common", "3.3")]
-  [PluginDependency("HeuristicLab.Core", "3.3")]
-  [PluginDependency("HeuristicLab.Core.Views", "3.3")]
-  [PluginDependency("HeuristicLab.MainForm", "3.3")]
-  [PluginDependency("HeuristicLab.MainForm.WindowsForms", "3.3")]
-  [PluginDependency("HeuristicLab.Problems.Instances", "3.3")]
-  [PluginDependency("HeuristicLab.Persistence", "3.3")]
-  public class Plugin : PluginBase {
-
-  }
-}
Index: /branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Tests/HeuristicLab.Tests.csproj
===================================================================
--- /branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Tests/HeuristicLab.Tests.csproj	(revision 15779)
+++ /branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Tests/HeuristicLab.Tests.csproj	(revision 15780)
@@ -8,5 +8,5 @@
     <AppDesignerFolder>Properties</AppDesignerFolder>
     <RootNamespace>HeuristicLab.Tests</RootNamespace>
-    <AssemblyName>F</AssemblyName>
+    <AssemblyName>HeuristicLab.Problems.ProgramSynthesis.Tests-3.3</AssemblyName>
     <TargetFrameworkVersion>v4.5</TargetFrameworkVersion>
     <FileAlignment>512</FileAlignment>
Index: /branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Tests/HeuristicLab.Tests.csproj.user
===================================================================
--- /branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Tests/HeuristicLab.Tests.csproj.user	(revision 15779)
+++ /branches/2895_PushGP_GenealogyAnalysis/HeuristicLab.Tests/HeuristicLab.Tests.csproj.user	(revision 15780)
@@ -2,5 +2,5 @@
 <Project ToolsVersion="14.0" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
   <PropertyGroup>
-    <ProjectView>ProjectFiles</ProjectView>
+    <ProjectView>ShowAllFiles</ProjectView>
   </PropertyGroup>
 </Project>